package ira;

import ira.export.Exporter;
import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.command.WrongUsageException;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextFormatting;

public class CommandIRA extends CommandBase {
    public String getName() {
        return "ira";
    }

    public String getUsage(ICommandSender sender) {
        return "/ira";
    }

    @Override
    public int getRequiredPermissionLevel() {
        return 0;
    }

    public void execute(MinecraftServer server, ICommandSender sender, String[] args) throws CommandException {
        if (args.length == 0) {
            sender.sendMessage(new TextComponentString(TextFormatting.RED + "/ira scale [value]"));
            sender.sendMessage(new TextComponentString(TextFormatting.AQUA + "修改渲染比例."));
            sender.sendMessage(new TextComponentString(TextFormatting.AQUA + "Current: " + IRA.renderScale));
            sender.sendMessage(new TextComponentString(TextFormatting.RED + "/ira all"));
            sender.sendMessage(new TextComponentString(TextFormatting.AQUA + "切换[所有模式]."));
            sender.sendMessage(new TextComponentString(TextFormatting.AQUA + "所有模式: " + Exporter.allMode));
        } else {
            switch (args[0].toLowerCase()) {
                case "scale":{
                    if (args.length == 2) {
                        float value = Float.parseFloat(args[1]);
                        IRA.renderScale = MathHelper.clamp(value, 0, 2);
                        sender.sendMessage(new TextComponentString(TextFormatting.GREEN + "Scale: " + value));
                    } else {
                        throw new WrongUsageException("/ira scale [value]");
                    }
                }
                break;
                case "all": {
                    Exporter.allMode = !Exporter.allMode;
                    sender.sendMessage(new TextComponentString(TextFormatting.GREEN + "所有模式: " + Exporter.allMode));
                }
                break;
            }
        }
    }
}
