package ira;

import com.google.common.collect.BiMap;
import ira.keybind.Keybinding;
import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.RenderItem;
import net.minecraft.item.Item;
import net.minecraftforge.client.ClientCommandHandler;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.fml.common.FMLLog;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.registries.GameData;
import org.apache.logging.log4j.Logger;
import org.lwjgl.opengl.GLContext;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Mod(modid = "irar", name = "Item Render Async Reloaded", version = "1.0.0", acceptedMinecraftVersions = "[1.12, 1.13)", clientSideOnly = true)
public class IRA {
    public static final int DEFAULT_MAIN_BLOCK_SIZE = 128;
    public static final int DEFAULT_GRID_BLOCK_SIZE = 32;
    public static final int DEFAULT_MAIN_ENTITY_SIZE = 512;
    public static final int DEFAULT_GRID_ENTITY_SIZE = 128;
    public static final int DEFAULT_PLAYER_SIZE = 1024;

    public static final Matcher FILE_NAME_MATCHER = Pattern.compile("[^A-Za-z0-9()\\[\\]]").matcher("");
    public static Minecraft mc;
    public static RenderItem itemRenderer;
    public static BiMap<Block, Item> B2I;

    public static float renderScale = 1;

    public static int mainBlockSize = 128,
            gridBlockSize = 32,
            mainEntitySize = 512,
            gridEntitySize = 128,
            playerSize = 1024;

    public static List<String> blacklist = new ArrayList<>();

    private static void syncConfig(Configuration cfg) {
        mainBlockSize = cfg.get("c", "RenderBlockMain", DEFAULT_MAIN_BLOCK_SIZE, "irar.cfg.mainblock").getInt();
        gridBlockSize = cfg.get("c", "RenderBlockGrid", DEFAULT_GRID_BLOCK_SIZE, "irar.cfg.gridblock").getInt();
        mainEntitySize = cfg.get("c", "RenderEntityMain", DEFAULT_MAIN_ENTITY_SIZE, "irar.cfg.mainentity").getInt();
        gridEntitySize = cfg.get("c", "RenderEntityGrid", DEFAULT_PLAYER_SIZE, "irar.cfg.gridentity").getInt();
        playerSize = cfg.get("c", "RenderPlayer", 1024, "irar.cfg.player").getInt();
        blacklist = Arrays.asList(cfg.get("c", "BlackList", new String[0], "irar.cfg.blacklist").getStringList());
        if (cfg.hasChanged())
            cfg.save();
    }

    private static Logger logger;
    public static Logger logger() {
        return logger;
    }

    @EventHandler
    public void preInit(FMLPreInitializationEvent event) {
        mc = Minecraft.getMinecraft();
        B2I = GameData.getBlockItemMap();
        logger = event.getModLog();

        syncConfig(new Configuration(event.getSuggestedConfigurationFile()));

        ///ForgeUtil.appendChildModTo(ImpLib.MODID);
    }

    @EventHandler
    public void init(FMLInitializationEvent event) {
        ClientCommandHandler.instance.registerCommand(new CommandIRA());

        if (!GLContext.getCapabilities().OpenGL32) {
            FMLLog.bigWarning("不支持OPENGL3.2! 可能会出错");
        }
        Keybinding.init();
    }

    @EventHandler
    public void postInit(FMLPostInitializationEvent event) {
        itemRenderer = mc.getRenderItem();
    }
}
