package ira.export;

import ira.rendering.FrameBufWrapper;
import ira.rendering.Renderer;
import net.minecraftforge.fml.common.registry.EntityEntry;
import roj.collect.MyHashMap;
import roj.config.data.CMapping;

public class EntityData {
    private static final FrameBufWrapper fboEntity = new FrameBufWrapper(200);

    private String name, engName;

    private final String owner, regName, icon;

    private final EntityEntry entity;

    public EntityData(EntityEntry entity) {
        this.owner = entity.getRegistryName().getNamespace();
        this.regName = entity.getRegistryName().toString();
        this.icon = Renderer.getEntityBase64(entity, fboEntity);
        this.entity = entity;
    }

    public EntityEntry getEntity() {
        return this.entity;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setEnglishName(String name) {
        this.engName = name;
    }

    static CMapping mapping = new CMapping(new MyHashMap<>(7));

    public StringBuilder toJSON(StringBuilder sb) {
        mapping.clear();

        mapping.put("name", name);
        mapping.put("Englishname", engName);
        mapping.put("mod", owner);
        mapping.put("registerName", regName);
        mapping.put("Icon", icon);

        return mapping.toShortJSON(sb);
    }
}
