package ira.keybind;

import ira.IRA;
import ira.export.Exporter;
import ira.rendering.FrameBufWrapper;
import ira.rendering.Renderer;
import net.minecraft.client.Minecraft;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemStack;
import net.minecraft.util.text.TextComponentString;
import net.minecraftforge.client.event.ClientChatEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.client.registry.ClientRegistry;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.InputEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;
import org.apache.logging.log4j.Level;
import org.lwjgl.opengl.GL11;

import java.io.IOException;

import static org.lwjgl.opengl.GL11.GL_TEXTURE_BINDING_2D;

/**
 * This file is a part of MI <br>
 * 版权没有, 仿冒不究,如有雷同,纯属活该 <br>
 *
 * @author solo6975
 * @since 2020/10/3 15:50
 */
public class Keybinding {

    static boolean readyToPressModId = false,
            renderPreview = false;
    static KeyBinding exportMod, renderEntity, renderEntityGrid, renderPlayer, toggleRender, renderInv;
    static FrameBufWrapper playerFBO, entityFBO, entityGridFBO, blockGridFBO;

    public static void init() {
        ClientRegistry.registerKeyBinding(exportMod = new KeyBinding("导出指定mod", 23, "IRA"));
        ClientRegistry.registerKeyBinding(toggleRender = new KeyBinding("切换渲染预览", 24, "IRA"));
        ClientRegistry.registerKeyBinding(renderPlayer = new KeyBinding("导出玩家", 25, "IRA"));
        ClientRegistry.registerKeyBinding(renderEntity = new KeyBinding("导出实体", 39, "IRA"));
        ClientRegistry.registerKeyBinding(renderEntityGrid = new KeyBinding("导出格子实体", 40, "IRA"));
        ClientRegistry.registerKeyBinding(renderInv = new KeyBinding("导出格子方块", 27, "IRA"));

        MinecraftForge.EVENT_BUS.register(Keybinding.class);
    }

    @SubscribeEvent
    public static void renderTick(TickEvent.RenderTickEvent event) {
        if (renderPreview && event.phase.ordinal() == 1 && exportMod != null) {
            int originalTexture = GL11.glGetInteger(GL_TEXTURE_BINDING_2D);

            blockGridFBO.bind();

            GL11.glBegin(GL11.GL_QUADS);
            GL11.glTexCoord2f(0, 0);
            GL11.glVertex2i(0, 0);
            GL11.glTexCoord2f(0, 1);
            GL11.glVertex2i(0, 128);
        }
    }

    @SubscribeEvent
    public static void onKeyInput(InputEvent.KeyInputEvent event) {
        if (IRA.mc.currentScreen != null)
            return;

        if (exportMod.isPressed()) {
            readyToPressModId = true;
            IRA.mc.player.sendMessage(new TextComponentString("请在聊天框输入modid"));
        } else if(renderPlayer.isPressed()) {
            Entity player = Minecraft.getMinecraft().getRenderViewEntity();
            if (player instanceof EntityLivingBase) {
                if(playerFBO == null)
                    playerFBO = new FrameBufWrapper(IRA.playerSize);
                Renderer.renderEntity((EntityLivingBase) player, playerFBO, "", true);
            }
        } else if (renderEntity.isPressed()) {
            if(entityFBO == null)
                entityFBO = new FrameBufWrapper(IRA.mainEntitySize);
            if (IRA.mc.pointedEntity != null)
                Renderer.renderEntity((EntityLivingBase) IRA.mc.pointedEntity, entityFBO, "", false);
        } else if (renderEntityGrid.isPressed()) {
            if(entityGridFBO == null)
                entityGridFBO = new FrameBufWrapper(IRA.gridEntitySize);
            if (IRA.mc.pointedEntity != null)
                Renderer.renderEntity((EntityLivingBase) IRA.mc.pointedEntity, entityGridFBO, "_grid", false);
        } else if(toggleRender.isPressed()) {
            renderPreview = !renderPreview;
        } else if(renderInv.isPressed()) {
            if (IRA.mc.player != null) {
                ItemStack current = IRA.mc.player.getHeldItemMainhand();
                if (current != null && current.getItem() != null) {
                    if(blockGridFBO == null)
                        blockGridFBO = new FrameBufWrapper(IRA.mainBlockSize);
                    Renderer.renderItem(current, blockGridFBO, "_grid", IRA.itemRenderer);
                }
            }
        }
    }

    @SubscribeEvent
    public static void onChatSend(ClientChatEvent event) {
        if (readyToPressModId) {
            String modid = event.getOriginalMessage();
            event.setCanceled(true);
            try {
                Exporter.exportMods(modid.trim().toLowerCase());
            } catch (IOException e) {
                IRA.mc.player.sendMessage(new TextComponentString("出现了错误! 请查看日志"));
                IRA.logger().catching(Level.FATAL, e);
            }
            readyToPressModId = false;
        }
    }
}
