package ira.util;

import javax.imageio.IIOException;
import javax.imageio.ImageIO;
import javax.imageio.ImageTypeSpecifier;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;
import java.awt.image.BufferedImage;
import java.awt.image.RenderedImage;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Iterator;

/**
 * This file is a part of MI <br>
 * 版权没有, 仿冒不究,如有雷同,纯属活该 <br>
 *
 * @author solo6975
 * @since 2020/10/3 19:04
 */
public final class PNGUtil {
    static ImageWriter imageWriter;

    public static void writeImage(RenderedImage im, OutputStream output) throws IOException {
        if (imageWriter == null)
            initImageIO();
        ImageWriter writer = imageWriter;
        if (writer == null)
            throw new IllegalStateException("Couldn't get png writer!");

        ImageOutputStream stream;
        try {
            stream = ImageIO.createImageOutputStream(output);
        } catch (IOException e) {
            throw new IIOException("Can't create output stream!", e);
        }

        writer.setOutput(stream);
        try {
            writer.write(im);
        } finally {
            writer.reset();
            output.flush();
        }
    }

    private static void initImageIO() {
        ImageTypeSpecifier intArgbSpecifier = ImageTypeSpecifier.createFromBufferedImageType(BufferedImage.TYPE_INT_ARGB);
        Iterator<ImageWriter> imageWriters = ImageIO.getImageWriters(intArgbSpecifier, "PNG");
        if (imageWriters.hasNext())
            imageWriter = imageWriters.next();
    }
}
